#'********************************************************************
#'*
#'*  Name:            CSI_AutoSwitchBitness.ps1 
#'*  Author:          Darwin Sanoy
#'*  Updates:         http://csi-windows.com/toolkit
#'*  Bug Reports &
#'*  Enhancement Req: http://CSI-Windows.com/about/contact-us
#'*
#'*  Built/Tested On: 32-bit Win7, 64-bit Win7
#'*  Requires:        OS: Vista, Windows 7, Server 2008
#'*     64-bit XP Requires Hotfix KB942589 to force a 32-bit script to run as 64-bit
#'*
#'*  COPYRIGHT NOTICE:  This script is Copyrighted by Synaptic Fireworks, LLC

#'*    If you received this script directly from CSI-Windows.com as a result
#'*    training, a conference or personal contact with staff, then you are 
#'*    allowed to use the script in your organization.
#'*
#'*    No public or private redistribution of this code is allowed.  This     
#'*    includes, but is not limited to, email, posting to websites, blogs 
#'*    or forums
#'*
#'*    This copyright notice and all comments in the script must remain intact.
#'*
#'*  Built/Tested On: 32-bit Win7, 64-bit Win7, 32-bit XP
#'*  Requires:        OS: XP, Vista, Windows 7, Server 2008
#'*     64-bit XP Requires Hotfix KB942589 to force a 32-bit script to run as 64-bit

#'*  Main Function:
#'*    a) Automatically switch the script to the desired bitness script engine
#'*    b) Don't get in the way if already running the correct bitness
#'*    c) If auto-switch to 64-bit is requested on 32-bit OS, run as 32-bit 
#'*       to allow one script to prefer 64-bit process on 64-bit OS, but run 
#'*       fine on 32-bit OS
#'*    d) One script works as expected on 64-bit processes, 32-bit processes
#'*       and 32-bit OSes (that don't have 64-bit processes)
#'*
#'*   Much easier than putting detection and repathing logic before every 
#'*   System32 call used in your Script (especially. reg.exe, regedit.exe, etc)
#'*
#'*  Version:         1.50
#'*
#'*  Revision History:
#'*        10/10/13 - 1.50 - handles both bound and unbound arguments.
#'*        10/03/12 - 1.35 - pass return code through from recursive call
#'*                        - fixed syntax of "-ExecutionPolicy"
#'*        06/22/11 - 1.3 - same code supports autoswitching to 32 or 64bit
#'*                       - bug fix: accurate value for %ProgramFiles(x86)
#'*        05/11/11 - 1.1 - inital version (djs)
#'*
#'*******************************************************************

<# The following param block just demonstrates that that code is capable of 
 Grabbing bound and non-bound parameters.  Leave it commented and use any parameters
 on the command line to see unbound processing.  Uncomment the param block to see
 a test of using bound parameters.
 #>
 
<# 
[CmdletBinding()]
param (
		[parameter(Mandatory=$false)][switch]$Fake1,  
    [parameter(Mandatory=$false)][string]$Fake2,
    [Parameter(Mandatory=$False,ValueFromPipeline=$True,ValueFromRemainingArguments=$True)][string[]]$Args
    
    )
#>

# If your script has a "param()" block - insert this code after the param block.

#  RequiredBitness Values: 
#      x86 = autoswitch to 32-bit
#    AMD64 = autoswitch to 64-bit

################ CORE CODE ####################
$RequiredBitness = "x86"
if ($RequiredBitness -eq "AMD64") {$SystemFolder = "sysnative"}
if ($RequiredBitness -eq "x86") {$SystemFolder = "sysWOW64"}

if (${env:\ProgramFiles(x86)} -ne $null) {
  if ($env:processor_architecture -ne $RequiredBitness) {
	
	  $argList += $MyInvocation.BoundParameters.GetEnumerator() | foreach {"-$($_.Key)", "$($_.Value)"}
    $argList += $MyInvocation.UnboundArguments
	
    &"$env:windir\$SystemFolder\windowspowershell\v1.0\powershell.exe" -noprofile -ExecutionPolicy bypass -file $myinvocation.Mycommand.path $arglist
    exit $LastExitCode 
  }
}
################ END CORE CODE ####################

#Replace the below demonstration lines with your real code
$argList += $MyInvocation.BoundParameters.GetEnumerator() | foreach {"-$($_.Key)", "$($_.Value)"}
$argList += $MyInvocation.UnboundArguments
Write-host "`r`nCSI_AutoSwitchBitness.ps1 by CSI_Windows.com`r`n`r`n" `
"[x86 = 32-bit, AMD64 = 64-bit]`r`n`r`n" `
"Running under: " $env:processor_architecture "`n`n" `
"With Arguments: $arglist`n`n"
"Press any key to continue ..."

$x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
